%define bname		Bitcoin
%define consensus_major	0
%define libconsensus	%mklibname %{name}consensus %{consensus_major}
%define consensus_devel	%mklibname %{name}consensus -d

Summary:	%{bname} payment network
Name:		bitcoin
Version:	0.16.3
Release:	%mkrel 1
License:	MIT
Group:		Office/Finance
Url:		http://www.bitcoin.org/
Source0:	https://github.com/bitcoin/bitcoin/archive/v%{version}/%{name}-%{version}.tar.gz
Source1:	bitcoin.service
Source3:	bitcoin.sysconfig
Source4:	bitcoin-tmpfiles.conf
BuildRequires:	boost-devel
BuildRequires:	db-devel >= 5.3.0
BuildRequires:	miniupnpc-devel
BuildRequires:	pkgconfig(libqrencode)
BuildRequires:	pkgconfig(dbus-1)
BuildRequires:	pkgconfig(protobuf)
BuildRequires:	protobuf-compiler
BuildRequires:	pkgconfig(openssl)
BuildRequires:	pkgconfig(Qt5Core)
BuildRequires:	pkgconfig(Qt5DBus)
BuildRequires:	pkgconfig(Qt5Gui)
BuildRequires:	pkgconfig(Qt5Network)
BuildRequires:	pkgconfig(Qt5Widgets)
BuildRequires:	qttools5
BuildRequires:	pkgconfig(libssl)
BuildRequires:	pkgconfig(libcrypto)
BuildRequires:	pkgconfig(protobuf)
BuildRequires:	pkgconfig(libevent)

%description
%{bname} is an innovative payment network and a new kind of money.

%package -n %{name}d
Summary:	%{bname} command line client
Group:		Office/Finance

%description -n %{name}d
%{name}d is the original %{bname} command line client.

%package qt
Summary:	%{bname} graphical Qt client
Group:		Office/Finance
Requires:	%{libconsensus} = %{version}

%description qt
%{bname}-Qt is the original %{bname} graphical client.

%package -n %{libconsensus}
Summary:	Shared libs for bitcoinconsensus
Group:		System/Libraries

%description -n %{libconsensus}
Shared libs for bitcoinconsensus.

%package -n %{consensus_devel}
Summary:	Development files for bitcoinconsensus
Group:		Development/C
Provides:	%{name}-devel = %{version}
Provides:	consensus-devel = %{version}
Requires:	%{libconsensus} = %{version}

%description -n %{consensus_devel}
This package contains development files for the bitcoinconsensus
library.

%prep
%setup -q

%build
export CPPFLAGS="%optflags -I%{_includedir}/db53 -fPIC"
./autogen.sh
%configure2_5x \
    BDB_INCLUDE_PATH=%{_includedir}/db53 \
    --disable-static \
    --disable-silent-rules \
    --with-incompatible-bdb

# full parallel build seems to fail in Qt, so limite to -j4 level:
%__make -j4

%install
%make_install
#

rm -f %{buildroot}%{_bindir}/test_*
find %{buildroot} -name '*.la' -delete

%{__mkdir_p} %{buildroot}%{_localstatedir}/lib/bitcoin
%{__mkdir_p} %{buildroot}%{_sysconfdir}/sysconfig
%{__install} %{SOURCE3} %{buildroot}%{_sysconfdir}/sysconfig/%{name}
%{__mkdir_p} %{buildroot}%{_unitdir}
%{__install} -p -m 0644 %{SOURCE1} %{buildroot}%{_unitdir}
%{__install} -D -p -m 0644 %{SOURCE4} %{buildroot}%{_tmpfilesdir}/%{name}.conf
%{__install} contrib/debian/examples/bitcoin.conf %{buildroot}%{_sysconfdir}

for size in 16 32 64 128 256; do
  %{__mkdir_p} %{buildroot}%{_iconsdir}/hicolor/${size}x${size}/apps
  %{__install} -m644 share/pixmaps/bitcoin${size}.png %{buildroot}%{_iconsdir}/hicolor/${size}x${size}/apps/%{name}.png
done

%{__mkdir_p} %{buildroot}%{_datadir}/bash-completion/completions
%{__install} -m 0644 contrib/bitcoind.bash-completion %{buildroot}%{_datadir}/bash-completion/completions/%{name}d

%{__mkdir_p} %{buildroot}%{_datadir}/applications
%{__install} -m 0644 contrib/debian/%{name}-qt.desktop %{buildroot}%{_datadir}/applications
perl -pi -e 's/bitcoin128/bitcoin/g' %{buildroot}%{_datadir}/applications/%{name}-qt.desktop

%{__mkdir_p} %{buildroot}%{_datadir}/kservices5
%{__install} -m 0644 contrib/debian/%{name}-qt.protocol %{buildroot}%{_datadir}/kservices5

%pre -n %{name}d
%_pre_useradd %{name} /dev/null /bin/false

%post -n %{name}d
if ! /usr/bin/id bitcoin &>/dev/null; then
       /usr/sbin/useradd -r -g bitcoin -s /bin/false -c "Bitcoin" -d /var/run/bitcoin bitcoin
fi
%_tmpfilescreate %{name}
%_post_service %{name}

%preun -n %{name}d
%_preun_service %{name}

%postun -n %{name}d
%_postun_userdel %{name}


%files -n %{name}d
%config (noreplace) %{_sysconfdir}/sysconfig/%{name}
%config (noreplace) %{_sysconfdir}/bitcoin.conf
%dir %attr(0750, bitcoin, bitcoin) %{_localstatedir}/lib/bitcoin
%{_unitdir}/%{name}.service
%{_tmpfilesdir}/%{name}.conf
%{_bindir}/%{name}d
%{_bindir}/%{name}-cli
%{_bindir}/%{name}-tx
%{_bindir}/bench_%{name}
%{_datadir}/bash-completion/completions/%{name}d
%{_mandir}/man1/bitcoin-cli.1.*
%{_mandir}/man1/bitcoin-tx.1.*
%{_mandir}/man1/bitcoind.1.*

%files qt
%{_bindir}/%{name}-qt
%{_datadir}/applications/%{name}-qt.desktop
%{_datadir}/kservices5/%{name}-qt.protocol
%{_iconsdir}/hicolor/*/apps/%{name}.png
%{_mandir}/man1/bitcoin-qt.1.*

%files -n %{libconsensus}
%{_libdir}/lib%{name}consensus.so.%{consensus_major}{,.*}

%files -n %{consensus_devel}
%{_includedir}/%{name}consensus.h
%{_libdir}/lib%{name}consensus.so
%{_libdir}/pkgconfig/lib%{name}consensus.pc


%changelog
* Sat Oct 13 2018 daviddavid <daviddavid> 0.16.3-1.mga6
+ Revision: 1319997
- new version: 0.16.3, fixes CVE-2018-17144 (mga#23681)
- add upstream desktop file and icons
- add upstream protocol file and bash completion
- systemd unit service

* Tue May 16 2017 neoclust <neoclust> 0.12.0-3.mga6
+ Revision: 1102002
- Rebuild against new miniupnpc

* Thu Feb 16 2017 mrambo3501 <mrambo3501> 0.12.0-2.mga6
+ Revision: 1086459
- rebuild for new libevent

* Tue Mar 01 2016 fwang <fwang> 0.12.0-1.mga6
+ Revision: 981277
- update file list
- update file list
- update file list
- add more br
- 0.12.0

* Sat Feb 13 2016 umeabot <umeabot> 0.11.0-8.mga6
+ Revision: 959605
- Mageia 6 Mass Rebuild
- Mageia 6 Mass Rebuild

* Sat Dec 26 2015 daviddavid <daviddavid> 0.11.0-6.mga6
+ Revision: 915162
- rebuild for new boost 1.60.0
- add missing BR on pkgconfig(openssl)

* Mon Oct 19 2015 fwang <fwang> 0.11.0-5.mga6
+ Revision: 892635
- disable static
- update file name
- add desc
- add shared libs
- turn back to qt4 flavour
- force fpic
- build qt5 with fpic
- use qt5 version of lrelease
- adopt to new api of miniupnpc
- build qt5 flavour
- rebuild for new miniupnpc

* Fri Sep 25 2015 daviddavid <daviddavid> 0.11.0-4.mga6
+ Revision: 883654
- rebuild for new boost 1.59.0

* Thu Sep 03 2015 cjw <cjw> 0.11.0-3.mga6
+ Revision: 872419
- rebuild with gcc 5

* Fri Jul 31 2015 daviddavid <daviddavid> 0.11.0-2.mga6
+ Revision: 859863
- rebuild for new boost-1.58.0

* Sat Jul 25 2015 blino <blino> 0.11.0-1.mga6
+ Revision: 857684
- add bitcoinconsensus devel package
- remove .la file
- package bitcoin-cli man page
- package bitcoin-tx tool
- 0.11.0

* Mon Jan 12 2015 buchan <buchan> 0.9.3-1.mga5
+ Revision: 810038
- Fix BDB detection in cauldron
- Update to 0.9.3
- ship man pages, bash completions etc.

* Wed Dec 17 2014 sander85 <sander85> 0.8.6-5.mga5
+ Revision: 803772
- Rebuild for miniupnpc

* Wed Oct 15 2014 umeabot <umeabot> 0.8.6-4.mga5
+ Revision: 740966
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 0.8.6-3.mga5
+ Revision: 678161
- Mageia 5 Mass Rebuild

* Wed May 14 2014 luigiwalser <luigiwalser> 0.8.6-2.mga5
+ Revision: 622816
- rebuild for miniupnpc

* Fri Jan 03 2014 blino <blino> 0.8.6-1.mga5
+ Revision: 564126
- initial Mageia package (0.8.6)
- Created package structure for bitcoin.

